#!/usr/bin/perl
####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: default.cgi
#  Description: manage default messages
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################
$0 =~ /^(.*)[\/\\].*/ && chdir ($1) ; $|=1;
use strict;
use CGI();
use DBI;
use lib './modules';
use GLOBAL;
use CONFIG;
my $in = new CGI;
   print $in->header();
my $data;
my $user = &GLOBAL::user;
   $data->{id} = $in->param('id') || undef;
   $data->{action} = $in->param('action') || undef;
   $data->{subject} = $in->param('subject') || undef;
   $data->{content} = $in->param('content') || undef;
   if ($data->{subject} && $data->{content} && $data->{action} eq "add") {
      $data = &GLOBAL::add_data($data,$CONFIG::default_table);
      &GLOBAL::template('default_added',$data,'navigation_category');
   }
   elsif ($data->{action} eq "add") {&GLOBAL::template('default_add_form',$data,'navigation_category');}
   elsif ($data->{action} eq "delete") {
      if (!$data->{id}) {&GLOBAL::error('noid');}
         my $record = &GLOBAL::get_record($data->{id},$CONFIG::default_table);
            if (!$record->{id}) {&GLOBAL::error('noid');}
      else {
         &GLOBAL::delete_record('id',$data->{id},$CONFIG::default_table);
         &GLOBAL::template('default_deleted',$data,'navigation_category');
      }
   }
   elsif ($data->{action} eq "view") {
      if ($data->{id}) {
         my $record = &GLOBAL::get_record($data->{id},$CONFIG::default_table);
            if (!$record->{id}) {&GLOBAL::error('noid');}
            &GLOBAL::template('default_view',$record,'navigation_category');
      }
   }
   elsif ($data->{action} eq "search") {
         if ($data->{action} = 'search' && ($data->{subject} || $data->{content})) {
               $data->{query} = &GLOBAL::search_data($data,$CONFIG::default_table);
               $data->{query} = $data->{query}->{query};
            my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { PrintError => 1, RaiseError => 1 });
            my $sth = $dbh->prepare (qq~$data->{query}~);
               $sth->execute ();
               $data->{count} = $sth->rows;
               if ($data->{count} > 0) {
               while (my @ary = $sth->fetchrow_array ()) {
                  $data->{results} .= qq~<tr>
                     <td>$ary[0]</td>
                     <td><a href=default.cgi?id=$ary[0]&action=view>$ary[1]</a></td>
                     <td><a href=default.cgi?id=$ary[0]&action=modify_form>$CONFIG::variables->{cmd_modify}</a></td>
                     <td><a href=default.cgi?id=$ary[0]&action=delete onClick="return confirm('Delete the record?')">$CONFIG::variables->{cmd_delete}</a></td>
                                         </tr>~;
               }
         }
         else {
            $data->{results} = qq~<tr><td colspan=2>$CONFIG::variables->{noresults}</td></tr>~;
            $data->{count} = qq~ 0 ~;
         }
         $sth->finish ();
         $dbh->disconnect ();
         &GLOBAL::template('default_search_results',$data,'navigation_category');
      }
      else {&GLOBAL::template('default_search_form',$data,'navigation_category');}
   }
   elsif ($data->{action} eq 'modify' && $data->{id}) {
      my $results = &GLOBAL::modify_data($data,$CONFIG::default_table);
         $data->{table_name} = $results->{table_name};
         $data->{table_results} = $results->{table_results};
         &GLOBAL::template('default_modified',$data,'navigation_category');
   }
   elsif ($data->{action} eq 'modify_form' && $data->{id}) {
      my $data = &GLOBAL::get_record($data->{id},$CONFIG::default_table);
         &GLOBAL::template('default_modify_form',$data,'navigation_category');
   }
   else {&GLOBAL::template('default_search_form',$data,'navigation_category');}
   exit;