#!/usr/bin/perl
####################################################################
#
#           _/       _/    _/_/_/_/    _/_/_/_/
#          _/ _/    _/    _/    _/    _/
#         _/   _/  _/    _/    _/    _/_/_/
#        _/     _/_/    _/    _/    _/
#       _/       _/    _/_/_/_/    _/_/_/_/
#
#         File: staff.cgi
#  Description: personal settings
#       Author: Niko Oeppert
#          Web: http://www.tulba.com/
#      Version: 1.53
# Copyright (c) 2004 Niko Oeppert
# Redistribution in part or in whole strictly prohibited.
#
####################################################################
$0 =~ /^(.*)[\/\\].*/ && chdir ($1) ; $|=1;
use strict;
use CGI();
use CGI::Carp('fatalsToBrowser');
use DBI;
use lib './modules';
use GLOBAL;
use CONFIG;
my $in = new CGI;
   print $in->header();
my $data;
my $user = &GLOBAL::user;
   if ($in->param('action') eq "modify_form") {
      if ($user->{access} eq "admin") {$data->{userid} = $in->param('userid');}
      else {$data->{userid} = $ENV{REMOTE_USER};}
      $data = &GLOBAL::get_record($data->{userid},$CONFIG::staff_table);
      if ($user->{access} eq "admin") {
          $data->{select_access}  = qq~<option value=$user->{access}>~ . $CONFIG::variables->{"ss_" . $user->{access}} . qq~</option>~;
          $data->{select_access} .= qq~<option value=admin>$CONFIG::variables->{ss_admin}</option>~;
          $data->{select_access} .= qq~<option value=regular>$CONFIG::variables->{ss_regular}</option>~;}
      else {$data->{select_access} = qq~<option value=$user->{access}>$CONFIG::variables->{"ss_" . $user->{access}}</option>~;}
      &GLOBAL::template('staff_modifyform',$data,'navigation_category');
   }
   elsif ($in->param('action') eq "modify" && ($in->param('userid') eq $ENV{REMOTE_USER} || $user->{access} eq "admin")) {
      $data->{userid} = $in->param('userid');
      $data->{name} = $in->param('name');
      $data->{given} = $in->param('given');
      $data->{pass} = $in->param('pass');
      if ($user->{access} eq "admin") {$data->{access} = $in->param('access');}
      else {$data->{access} = $user->{access};}
      &GLOBAL::modify_data($data,$CONFIG::staff_table);
      &update_pass;
      $data->{access} = $CONFIG::variables->{"ss_" . $data->{access}};
      &GLOBAL::template('staff_modified',$data,'navigation_category');
   }
   elsif ($in->param('action') eq "add_form" && $user->{access} eq "admin") {
      &GLOBAL::template('staff_addform',$data,'navigation_category');
   }
   elsif ($in->param('action') eq "add" && $user->{access} eq "admin") {
      $data->{pass} = $in->param('pass') || undef;
      $data->{userid} = $in->param('userid') || undef;
      if (length($data->{pass}) < 5 || length($data->{userid}) < 5 || $data->{userid} =~ /[^A-Za-z0-9]/) {&GLOBAL::error('userparam');}
      $data->{name} = $in->param('name');
      $data->{given} = $in->param('given');
      $data->{pass} = $in->param('pass');
      $data->{access} = $in->param('access');
      my $record = &GLOBAL::get_record($data->{userid},$CONFIG::staff_table);
         if ($record->{'userid'} || $data->{'userid'} eq "service") {&GLOBAL::error('duplicate');}
      &GLOBAL::add_data($data,$CONFIG::staff_table);
      &update_pass;
      $data->{access} = $CONFIG::variables->{"ss_" . $data->{access}};
      &GLOBAL::template('staff_added',$data,'navigation_category');
   }
   elsif ($in->param('action') eq "delete" && $user->{access} eq "admin") {
         $data->{message} = "$CONFIG::varibles->{deleted}";
         $data->{userid} = $in->param('userid');
      my $record = &GLOBAL::get_record($data->{userid},$CONFIG::staff_table);
         if ($record->{'userid'}) {&GLOBAL::delete_record('userid',$record->{userid},$CONFIG::staff_table);}
         else {$data->{message} = qq~$CONFIG::variables->{noresults}: $record->{userid}~;}
         &update_pass;
         &GLOBAL::template('staff_deleted',$data,'navigation_category');
   }
   else {
         if ($user->{access} eq "admin") {$data->{userid} = "%";}
         else {$data->{userid} = $ENV{REMOTE_USER};}
      my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { RaiseError => 1 });
      my $sth = $dbh->prepare (qq~SELECT * FROM $CONFIG::staff_table WHERE userid LIKE '$data->{userid}'~);
         $sth->execute ();
         while (my @ary = $sth->fetchrow_array ()) {
            $ary[4] = $CONFIG::variables->{"ss_" . $ary[4]};
            $data->{results} .= qq~
            <tr>
                <td>$ary[0]&nbsp;</td>
                <td>$ary[1]&nbsp;</td>
                <td>$ary[2]&nbsp;</td>
                <td>$ary[3]&nbsp;</td>
                <td>$ary[4]&nbsp;</td>
                <td><nobr><a href="staff.cgi?userid=$ary[0]&action=modify_form">$CONFIG::variables->{'cmd_modify'}</a>&nbsp;~;
            if ($user->{access} eq "admin") {$data->{results} .= qq~<a href="staff.cgi?userid=$ary[0]&action=delete" onClick="return confirm('delete record?')">$CONFIG::variables->{cmd_delete}</a>~;}
            $data->{results} .= qq~
               </nobr>
                  </td>
               </tr>
               ~;
         }
         $sth->finish ();
         $dbh->disconnect ();
         if ($user->{access} eq "admin") {$data->{add_user} = qq~<p><a href=staff.cgi?action=add_form>$CONFIG::variables->{'cmd_add'}</a></p>~;}
         &GLOBAL::template('staff_list',$data,'navigation_category');
   }
exit (0);
####################################################################
# update_pass
####################################################################
sub update_pass {
my $user_pass;
my $dbh = DBI->connect ($CONFIG::dsn, $CONFIG::username, $CONFIG::password, { RaiseError => 1 });
my $sth = $dbh->prepare (qq~SELECT userid,pass FROM $CONFIG::staff_table~);
   $sth->execute ();
   while (my @ary = $sth->fetchrow_array ()) {
      my $cryptedpass = crypt($ary[1], "MM");
         $user_pass .= qq~$ary[0]:$cryptedpass\n~;
   }
   $sth->finish ();
   $dbh->disconnect ();
   open(TOFILE,"> .htpasswd") || &GLOBAL::error('nofile');
   print TOFILE "$user_pass";
   close(TOFILE);
}
1;